"""
integrals on  tetrahedrons
"""

#identical tetrahedron
function k6p_ct(f, x1, x2, x3, y1, y2, y3)
    #sum = 0;
    
     #Domain 2/17
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y1 * y3

    det = x1^5*x2^4*x3^3*y1^2

    sum = f((1-ξ1,ξ1-ξ2,ξ3-η1+η2),(1-(ξ1-η3),ξ1-ξ2+η1-η3,ξ3-η1))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2+η1-η3,ξ3-η1),(1-ξ1,ξ1-ξ2,ξ3-η1+η2))*det

    
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y1 * y2 * y3

    det = x1^5*x2^4*x3^3*y1^2*y2

    #Domain 1/18
    sum += f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-η2+η3),ξ1-ξ2+η3,ξ3-η1))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2+η3,ξ3-η1),(1-ξ1,ξ1-ξ2,ξ3))*det

    #Domain 3/16
    sum += f((1-ξ1,ξ1-ξ2,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2),(1-ξ1,ξ1-ξ2,ξ3-η1),)*det
    
    #Domain 4/15
    sum += f((1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3),(1-(ξ1-η2),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3))*det
    
    #Domain 5/14
    sum += f((1-ξ1,ξ1-ξ2+η1-η2,ξ3-η1+η3),(1-(ξ1-η1),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η2,ξ3-η1+η3))*det
    
    #Domain 6/13
    sum += f((1-ξ1,ξ1-ξ2+η3,ξ3-η1),(1-(ξ1-η2),ξ1-ξ2,ξ3-η2))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η2),(1-ξ1,ξ1-ξ2+η3,ξ3-η1))*det
    
    #Domain 7/12
    sum += f((1-ξ1,ξ1-ξ2+η1-η3,ξ3-η1+η3),(1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η3,ξ3-η1+η3))*det
    
    #Domain 8/11
    sum += f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2,ξ3-η1+η2-η3))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2,ξ3-η1+η2-η3),(1-ξ1,ξ1-ξ2+η1,ξ3-η1))*det
    
    #Domain 9/10
    sum += f((1-ξ1,ξ1-ξ2+η2,ξ3-η1),(1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η2+η3))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η2+η3),(1-ξ1,ξ1-ξ2+η2,ξ3-η1))*det

    return sum
end

function k6p_ct_A(f, x1, x2, x3, x4, y1, z1)
    #sum = 0;
    
    #Domain 2/17
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3
    #=4=#   η1 = x4
    #=5=#   η2 = x4 * y1
    #=6=#   η3 = x4 * z1 

    det = x4^2

    sum = f((1-ξ1,ξ1-ξ2,ξ3-η1+η2),(1-(ξ1-η3),ξ1-ξ2+η1-η3,ξ3-η1))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2+η1-η3,ξ3-η1),(1-ξ1,ξ1-ξ2,ξ3-η1+η2))*det
    
    return sum 
end

function k6p_ct_B(f, x1, x2, x3, x4, y1, y2)
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3
    #=4=#   η1 = x4
    #=5=#   η2 = x4 * y1
    #=6=#   η3 = x4 * y2 

    det = x4^2

    #Domain 1/18
    sum = f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-η2+η3),ξ1-ξ2+η3,ξ3-η1))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2+η3,ξ3-η1),(1-ξ1,ξ1-ξ2,ξ3))*det
   
    #Domain 3/16
    sum += f((1-ξ1,ξ1-ξ2,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2),(1-ξ1,ξ1-ξ2,ξ3-η1),)*det
    
    #Domain 4/15
    sum += f((1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3),(1-(ξ1-η2),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3))*det
    
    #Domain 5/14
    sum += f((1-ξ1,ξ1-ξ2+η1-η2,ξ3-η1+η3),(1-(ξ1-η1),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η2,ξ3-η1+η3))*det
    
    #Domain 6/13
    sum += f((1-ξ1,ξ1-ξ2+η3,ξ3-η1),(1-(ξ1-η2),ξ1-ξ2,ξ3-η2))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η2),(1-ξ1,ξ1-ξ2+η3,ξ3-η1))*det
    
    #Domain 7/12
    sum += f((1-ξ1,ξ1-ξ2+η1-η3,ξ3-η1+η3),(1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η1))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η3,ξ3-η1+η3))*det
    
    #Domain 8/11
    sum += f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2,ξ3-η1+η2-η3))*det

    sum += f((1-(ξ1-η3),ξ1-ξ2,ξ3-η1+η2-η3),(1-ξ1,ξ1-ξ2+η1,ξ3-η1))*det
    
    #Domain 9/10
    sum += f((1-ξ1,ξ1-ξ2+η2,ξ3-η1),(1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η2+η3))*det

    sum += f((1-(ξ1-η2+η3),ξ1-ξ2,ξ3-η2+η3),(1-ξ1,ξ1-ξ2+η2,ξ3-η1))*det

    return sum
end

#overlapping face
function k6p_cf(f, x1, x2, x3, y1, y2, y3)
    #sum = 0;
    
    #Domain 1
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y3

    det = x1^5*x2^4*x3^3*y1

    #sum += f((ξ1,ξ2,η3),(ξ1-ξ3+η1,ξ2-ξ3+η2,η2))*det
    sum = f((1-ξ1,ξ1-ξ2,ξ3-η3),(1-(ξ1-ξ3+η1),ξ1-ξ2+η2,η1-η2))*det


    #Domain 3/5/13
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y1 * y3

    det = x1^5*x2^4*x3^3*y1^2
    
    sum += f((1-ξ1,ξ1-ξ2+ξ3-η1,η1-η2),(1-(ξ1-ξ3+η3),ξ1-ξ2,η3))*det
    
    sum += f((1-(ξ1-ξ3+η1),ξ1-ξ2,η1-η3),(1-ξ1,ξ1-ξ2+ξ3-η2,η2))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2+η1-η2,ξ3-η1),(1-ξ1,ξ1-ξ2,η3))*det
    

    #Domain 2/4/6-12/14-15
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y1 * y2 * y3

    det = x1^5*x2^4*x3^3*y1^2*y2
    
    sum += f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-η1+η2),ξ1-ξ2+ξ3-η1,η3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ3-η1,η1),(1-(ξ1-ξ3+η2),ξ1-ξ2,η2-η3))*det
   
    sum += f((1-(ξ1-ξ3+η1),ξ1-ξ2,η1),(1-ξ1,ξ1-ξ2+ξ3-η2,η3))*det
    
    sum += f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η2,η2-η3))*det
       
    sum += f((1-(ξ1-η2),ξ1-ξ2,η1-η2),(1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3))*det
  
    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η2),(1-ξ1,ξ1-ξ2+η3,η1-η3))*det
       
    sum += f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2,η2-η3))*det
        
    sum += f((1-ξ1,ξ1-ξ2+η2,η1-η2),(1-(ξ1-η3),ξ1-ξ2,ξ3-η3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+η2,ξ3-η2),(1-(ξ1-η2+η3),ξ1-ξ2,η1-η2+η3))*det
    
    sum += f((1-(ξ1-η2+η3),ξ1-ξ2+η3,η1-η2),(1-ξ1,ξ1-ξ2,ξ3))*det
    
    sum += f((1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2),(1-ξ1,ξ1-ξ2,η1))*det

    return sum
end

function k6p_cf_A(f, x1, x2, x3, y1, y2, z1)
    #sum = 0;
    
    #Domain 1
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3
    #=4=#   η1 = x3 * y1
    #=5=#   η2 = x3 * y2
    #=6=#   η3 = x3 * z1

    det = x3^3

    sum = f((1-ξ1,ξ1-ξ2,ξ3-η3),(1-(ξ1-ξ3+η1),ξ1-ξ2+η2,η1-η2))*det

    return sum
end 

function k6p_cf_B(f, x1, x2, x3, y1, y2, z1)
    #sum = 0;

    #Domain 3/5/13
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3
    #=4=#   η1 = x3 * y1
    #=5=#   η2 = x3 * y2
    #=6=#   η3 = x3 * y1 * z1

    det = x3^3*y1
    
    sum = f((1-ξ1,ξ1-ξ2+ξ3-η1,η1-η2),(1-(ξ1-ξ3+η3),ξ1-ξ2,η3))*det
    
    sum += f((1-(ξ1-ξ3+η1),ξ1-ξ2,η1-η3),(1-ξ1,ξ1-ξ2+ξ3-η2,η2))*det

    sum += f((1-(ξ1-η2),ξ1-ξ2+η1-η2,ξ3-η1),(1-ξ1,ξ1-ξ2,η3))*det
    
    return sum
end 

function k6p_cf_C(f, x1, x2, x3, y1, y2, y3)
    #sum = 0;
    #Domain 2/4/6-12/14-15
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3
    #=4=#   η1 = x3 * y1
    #=5=#   η2 = x3 * y2
    #=6=#   η3 = x3 * y3

    det = x3^3
    
    sum = f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-η1+η2),ξ1-ξ2+ξ3-η1,η3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ3-η1,η1),(1-(ξ1-ξ3+η2),ξ1-ξ2,η2-η3))*det
   
    sum += f((1-(ξ1-ξ3+η1),ξ1-ξ2,η1),(1-ξ1,ξ1-ξ2+ξ3-η2,η3))*det
    
    sum += f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-ξ2+η1-η2,η2-η3))*det
       
    sum += f((1-(ξ1-η2),ξ1-ξ2,η1-η2),(1-ξ1,ξ1-ξ2+η2-η3,ξ3-η2+η3))*det
  
    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ3-η2),(1-ξ1,ξ1-ξ2+η3,η1-η3))*det
       
    sum += f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1-η3),ξ1-ξ2,η2-η3))*det
        
    sum += f((1-ξ1,ξ1-ξ2+η2,η1-η2),(1-(ξ1-η3),ξ1-ξ2,ξ3-η3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+η2,ξ3-η2),(1-(ξ1-η2+η3),ξ1-ξ2,η1-η2+η3))*det
    
    sum += f((1-(ξ1-η2+η3),ξ1-ξ2+η3,η1-η2),(1-ξ1,ξ1-ξ2,ξ3))*det
    
    sum += f((1-(ξ1-η3),ξ1-ξ2+η2-η3,ξ3-η2),(1-ξ1,ξ1-ξ2,η1))*det

    return sum
end

#overlapping edge 
function k6p_ce(f, x1, x2, x3, y1, y2, y3)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 *y1
    #=5=#   η2 = x1 * x2 * y2
    #=6=#   η3 = x1 * x2 * y2 * y3
    
    det = x1^5*x2^4*x3*y2
    #Domain 1
    sum = f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1+η2-ξ2),ξ1-ξ2,η2-η3))*det
    
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * y3
    
    det = x1^5*x2^4*x3^2*y1

    #Domain 2
    sum += f((1-ξ1,ξ1-ξ2,ξ2-η3),(1-(ξ1-ξ2+ξ3),ξ1-ξ2+ξ3-η1,η2))*det

    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * x3 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * x3 * y1 * y2 * y3
    
    det = x1^5*x2^4*x3^3*y1^2*y2
    
    #Domain 3 
    sum += f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-η2,η3))*det

    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * y1
    #=5=#   η2 = x1 * x2 * y1 * y2
    #=6=#   η3 = x1 * x2 * y1 * y2 * y3
    
    det = x1^5*x2^4*y1^2*y2

    #Domain 4
    sum += f((1-(ξ1-η3),ξ1-η1,η2-η3),(1-ξ1,ξ1-ξ2,ξ3))*det

    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = x1 * x2 * y1
    #=5=#   η2 = x1 * x2 * x3 * y1 * y2
    #=6=#   η3 = x1 * x2 * y1 * y3
    
    det = x1^5*x2^4*x3*y1^2

    #Domain 5
    sum += f((1-(ξ1-η2),ξ1-ξ2,ξ2-ξ3),(1-ξ1,ξ1-η1,η3))*det
    
    return sum
end


function k6p_ce_A(f, x1, x2, y1, y2, z1, z2)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   η1 = x2 * y2
    #=5=#   η2 = x2 * z1
    #=6=#   η3 = x2 * z2
    
    det = x2^4
    #Domain 1
    sum = f((1-ξ1,ξ1-ξ2+η1,ξ3-η1),(1-(ξ1+η2-ξ2),ξ1-ξ2,η2-η3))*det

    return sum
end

function k6p_ce_B(f, x1, x2, y1, y2, y3, z1)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   η1 = x2 * y2
    #=5=#   η2 = x2 * y3
    #=6=#   η3 = x2 * z1
    
    det = x2^4

    #Domain 2
    sum = f((1-ξ1,ξ1-ξ2,ξ2-η3),(1-(ξ1-ξ2+ξ3),ξ1-ξ2+ξ3-η1,η2))*det

    return sum
end

function k6p_ce_C(f, x1, x2, y1, y2, y3, y4)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   η1 = x2 * y2
    #=5=#   η2 = x2 * y3
    #=6=#   η3 = x2 * y4
    
    det = x2^4
    
    #Domain 3 
    sum = f((1-(ξ1-η1),ξ1-ξ2,ξ3-η1),(1-ξ1,ξ1-η2,η3))*det
    return sum
end

function k6p_ce_D(f, x1, x2, y1, z1, z2, z3)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   η1 = x2 * z1
    #=5=#   η2 = x2 * z2
    #=6=#   η3 = x2 * z3
    
    det = x2^4

    #Domain 4
    sum = f((1-(ξ1-η3),ξ1-η1,η2-η3),(1-ξ1,ξ1-ξ2,ξ3))*det
    return sum
end

function k6p_ce_E(f, x1, x2, y1, z1, z2, w1)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   η1 = x2 * z1
    #=5=#   η2 = x2 * y1 * z2
    #=6=#   η3 = x2 * z1 * w1
    
    det = x2^4*y1*z1

    #Domain 5
    sum = f((1-(ξ1-η2),ξ1-ξ2,ξ2-ξ3),(1-ξ1,ξ1-η1,η3))*det
    
    return sum
end

#overlapping vertex
function k6p_cv(f, η1, η2, η3, η4, ξ1, ξ2)
    
    ξ1η1   = ξ1 * η1
    ξ1η1η2 = ξ1 * η1 * η2
    
    ξ1ξ2     = ξ1 * ξ2
    ξ1ξ2η3   = ξ1 * ξ2 * η3
    ξ1ξ2η3η4 = ξ1 * ξ2 * η3 * η4
    
    ((ξ1^5) * η1 * (ξ2^2) * η3) *(

    f((1-ξ1,ξ1η1-ξ1η1η2,ξ1η1η2),(1-ξ1ξ2,ξ1ξ2η3-ξ1ξ2η3η4,ξ1ξ2η3η4))+
    
    f((1-ξ1ξ2,ξ1ξ2η3-ξ1ξ2η3η4,ξ1ξ2η3η4),(1-ξ1,ξ1η1-ξ1η1η2,ξ1η1η2))

    )

end

function k6p_cv_A(f, x1, x2, x3, y1, y2, y3)
    #sum = 0;
    
    sum = f((1-x1,x1-x2,x3),(1-x1*y1,x1*y1-x1*y2,x1*y3))*(x1^3)

    sum += f((1-x1*y1,x1*y1-x1*y2,x1*y3),(1-x1,x1-x2,x3))*(x1^3)
    
    return sum
end

#positive distance
function k6p_pd(f, x1, x2, x3, y1, y2, y3)
   
    #sum = 0;
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   η1 = y1
    #=5=#   η2 = y1 * y2
    #=6=#   η3 = y1 * y2 * y3
    
    det = x1^2*x2*y1^2*y2
    #Domain 1
    sum = f((1-ξ1,ξ1-ξ2,ξ3),(1-η1,η1-η2,η3))*det

    return sum
end

function k6p_pd_A(f, x1, x2, x3, y1, y2, y3)
   
    #sum = 0;
    #Domain 1
    sum = f((1-x1,x1-x2,x3),(1-y1,y1-y2,y3))

    return sum
end

"""
integrals on  tetrahedron and triagle
"""

### Common Face ###
function k5p_cf(f, x1, x2, x3, y1, y2)
    #sum = 0;
    
    #Domain 1
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   ξ4 = x1 * x2 * x3 *y1
    #=5=#   ξ5 = x1 * x2 * x3 *y2
    
    det = x1^4*x2^3*x3^2

    sum = f((1-ξ1,ξ1-ξ2,ξ3-ξ4),(1-(ξ1-ξ3+ξ5),ξ2-ξ3))*det
    
    #Domain 2-9
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   ξ4 = x1 * x2 * x3 *y1
    #=5=#   ξ5 = x1 * x2 * x3 *y1*y2
    
    det = x1^4*x2^3*x3^2*y1

    sum += f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-ξ5),ξ2-ξ3+ξ4-ξ5))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ4-ξ5,ξ3-ξ4),(1-(ξ1-ξ3),ξ2-ξ3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ3-ξ4,ξ4),(1-(ξ1-ξ3+ξ5),ξ2-ξ3+ξ5))*det
    
    sum += f((1-(ξ1-ξ5),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ2-ξ3))*det
    
    sum += f((1-(ξ1-ξ4+ξ5),ξ1-ξ2,ξ3-ξ4+ξ5),(1-ξ1,ξ2-ξ3+ξ5))*det

    sum += f((1-(ξ1-ξ4),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ2-ξ4+ξ5))*det

    sum += f((1-ξ1,ξ1-ξ2+ξ3-ξ4+ξ5,ξ4-ξ5),(1-(ξ1-ξ3+ξ4),ξ2-ξ3+ξ4))*det
    
    sum += f((1-(ξ1-ξ4+ξ5),ξ1-ξ2+ξ5,ξ3-ξ4),(1-ξ1,ξ2))*det

    return sum
end

function k5p_cf_A(f, x1, x2, x3, y1, z1)
    #sum = 0;
    
    #Domain 1
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3 
    #=4=#   ξ4 = x3 * y1 
    #=5=#   ξ5 = x3 * z1
    
    det = x3^2

    sum = f((1-ξ1,ξ1-ξ2,ξ3-ξ4),(1-(ξ1-ξ3+ξ5),ξ2-ξ3))*det
    
    return sum
end


function k5p_cf_B(f, x1, x2, x3, y1, y2)
    #sum = 0;

    #Domain 2-9
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3 
    #=4=#   ξ4 = x3 * y1
    #=5=#   ξ5 = x3 * y2
    
    det = x3^2

    sum = f((1-ξ1,ξ1-ξ2,ξ3),(1-(ξ1-ξ5),ξ2-ξ3+ξ4-ξ5))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ4-ξ5,ξ3-ξ4),(1-(ξ1-ξ3),ξ2-ξ3))*det
    
    sum += f((1-ξ1,ξ1-ξ2+ξ3-ξ4,ξ4),(1-(ξ1-ξ3+ξ5),ξ2-ξ3+ξ5))*det
    
    sum += f((1-(ξ1-ξ5),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ2-ξ3))*det
    
    sum += f((1-(ξ1-ξ4+ξ5),ξ1-ξ2,ξ3-ξ4+ξ5),(1-ξ1,ξ2-ξ3+ξ5))*det

    sum += f((1-(ξ1-ξ4),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ2-ξ4+ξ5))*det

    sum += f((1-ξ1,ξ1-ξ2+ξ3-ξ4+ξ5,ξ4-ξ5),(1-(ξ1-ξ3+ξ4),ξ2-ξ3+ξ4))*det
    
    sum += f((1-(ξ1-ξ4+ξ5),ξ1-ξ2+ξ5,ξ3-ξ4),(1-ξ1,ξ2))*det

    return sum
end


### Common Edge ###
function k5p_ce(f, x1, x2, x3, y1, y2)
    #sum = 0;
    
    #Domain 1/2
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   ξ4 = x1 * x2 * x3 *y1
    #=5=#   ξ5 = x1 * x2 * y2
    
    det = x1^4*x2^3*x3
 
    sum = f((1-ξ1,ξ1-ξ3,ξ4),(1-(ξ1-ξ5),ξ2-ξ5))*det

    sum += f((1-ξ1,ξ1-ξ2,ξ5),(1-(ξ1-ξ4),ξ3-ξ4))*det
    
    #Domain 3/4
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   ξ4 = x1 * x2 * x3 *y1
    #=5=#   ξ5 = x1 * x2 * x3 *y1* y2
    
    det = x1^4*x2^3*x3^2*y1

    sum += f((1-(ξ1-ξ4),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ5))*det

    sum += f((1-(ξ1-ξ5),ξ1-ξ3,ξ4-ξ5),(1-ξ1,ξ2))*det
    
    #Domain 5
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x1 * x2
    #=3=#   ξ3 = x1 * x2 * x3
    #=4=#   ξ4 = x1 * x2 * x3 *y1
    #=5=#   ξ5 = x1 * x2 * x3 *y2
    
    det = x1^4*x2^3*x3^2

    sum += f((1-(ξ1-ξ2+ξ3),ξ1-ξ2,ξ4),(1-ξ1,ξ2-ξ3+ξ5))*det
    
    return sum
    
end

function k5p_ce_A(f, x1, x2, y1, y2, z1)
    #sum = 0;
    
    #Domain 1/2
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   ξ4 = x2 * y2 
    #=5=#   ξ5 = x2 * z1
    
    det = x2^3
 
    sum = f((1-ξ1,ξ1-ξ3,ξ4),(1-(ξ1-ξ5),ξ2-ξ5))*det
    
    sum += f((1-ξ1,ξ1-ξ2,ξ5),(1-(ξ1-ξ4),ξ3-ξ4))*det
   
    return sum 
end

function k5p_ce_B(f, x1, x2, y1, y2, y3)
    #sum = 0;
       
    #Domain 3/4
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   ξ4 = x2 * y2
    #=5=#   ξ5 = x2 * y3
    
    det = x2^3

    sum = f((1-(ξ1-ξ4),ξ1-ξ2,ξ3-ξ4),(1-ξ1,ξ5))*det

    sum += f((1-(ξ1-ξ5),ξ1-ξ3,ξ4-ξ5),(1-ξ1,ξ2))*det
    
    return sum
end

function k5p_ce_C(f, x1, x2, y1, y2, z1)
    #sum = 0;
    
    #Domain 5
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   ξ4 = x2 * y2
    #=5=#   ξ5 = x2 * y1 * z1
    
    det = x2^3*y1

    sum = f((1-(ξ1-ξ2+ξ3),ξ1-ξ2,ξ4),(1-ξ1,ξ2-ξ3+ξ5))*det
    
    return sum
end



### Common Vertex ###
function k5p_cv(f, x1, x2, x3, x4, x5)
    #sum = 0;
    
    sum = f((1-x1,x1-x1*x2,x1*x2*x3),(1-x1*x4,x1*x4*x5))*(x1^4*x2*x4)
    
    sum += f((1-x1*x3,x1*x3-x1*x3*x4,x1*x3*x4*x5),(1-x1,x1*x2))*(x1^4*x3^2*x4)

   
    return sum
end

function k5p_cv_A(f, x1, x2, x3, x4, x5)
    #sum = 0;
    
    sum = f((1-x1,x1-x2,x3),(1-x1*x4,x1*x5))*(x1^2)
    
    sum += f((1-x4*x1,x4*x1-x4*x2,x4*x3),(1-x4,x5))*(x4^3)

   
    return sum
end

### Positive Distance ###
function k5p_pd(f, x1, x2, x3, y1, y2)
   
    #u = [1-x1, x1-x1*x2, x1*x2*x3] #jacobian x1^2*x2
    #v = [1-y1, y1*y2] #jacobian y1 

    return f((1-x1, x1-x1*x2, x1*x2*x3),(1-y1, y1*y2))*(x1^2*x2)*(y1)
end

function k5p_pd_A(f, x1, x2, x3, y1, y2)
   
    #u = [1-x1, x1-x2, x3] 
    #v = [1-y1, y2]  

    return f((1-x1, x1-x2, x3),(1-y1, y2))
end


"""
Integrals on triangles
"""
### Common Face ###
function k4p_cf(f, η1, η2, η3, ξ)

	(ξ^3)*((η1)^2)*(η2)*(

    f((1-ξ, ξ-ξ*η1+ξ*η1*η2), (1-(ξ-ξ*η1*η2*η3), ξ-ξ*η1)) +

	f((1-(ξ-ξ*η1*η2*η3), ξ-ξ*η1), (1-ξ, ξ-ξ*η1+ξ*η1*η2))  +

	f((1-ξ, ξ*η1*(1-η2+η2*η3)), (1-(ξ-ξ*η1*η2), ξ*η1*(1-η2))) +

	f((1-(ξ-ξ*η1*η2), ξ*η1*(1-η2)), (1-ξ, ξ*η1*(1-η2+η2*η3))) +

	f((1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)), (1-ξ, ξ*η1*(1-η2))) +

	f((1-ξ, ξ*η1*(1-η2)), (1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)))
    
    )
end

function k4p_cf_A(f, x1, x2, x3, y1)

	#sum = 0;
    #Domain 1-6
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x3 
    #=4=#   ξ4 = x3 * y1

    det = x3

    sum=f((1-ξ1,ξ1-ξ2+ξ3),(1-(ξ1-ξ4),ξ1-ξ2))*det

    sum+=f((1-(ξ1-ξ4),ξ1-ξ2),(1-ξ1,ξ1-ξ2+ξ3))*det

    sum+=f((1-ξ1,ξ2-ξ3+ξ4),(1-(ξ1-ξ3),ξ2-ξ3))*det

    sum+=f((1-(ξ1-ξ3),ξ2-ξ3),(1-ξ1,ξ2-ξ3+ξ4))*det

    sum+=f((1-(ξ1-ξ4),ξ2-ξ4),(1-ξ1,ξ2-ξ3))*det

    sum+=f((1-ξ1,ξ2-ξ3),(1-(ξ1-ξ4),ξ2-ξ4))*det

    return sum
end

### Common edge ###
function k4p_ce(f, η1, η2, η3, ξ)

	ξη1 = ξ * η1
	η1η2 = η1 * η2
	η2η3 = η2 * η3
	η1η2η3 = η1η2 * η3

	(ξ^3)*((η1)^2) *f((1-ξ, ξη1*η3), (1-ξ*(1-η1η2), ξη1*(1-η2))) +  

	(ξ^3)*((η1)^2)*(η2)*(
	f((1-ξ, ξη1), (1-ξ*(1-η1η2η3), ξη1*η2*(1-η3))) +

	f((1-ξ*(1-η1η2), ξη1*(1-η2)), (1-ξ, ξη1*η2η3)) +
    
	f((1-ξ*(1-η1η2η3), ξη1*η2*(1-η3)), (1-ξ, ξη1)) +

	f((1-ξ*(1-η1η2η3), ξη1*(1-η2η3)), (1-ξ, ξη1*η2))
	)
end

function k4p_ce_A(f, x1, x2, y1, z1)
   # sum = 0;

    #Domain 1
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2*y1
    #=4=#   ξ4 = x2 *z1

    det = x2^2

    sum=f((1-ξ1,ξ4),(1-(ξ1-ξ3),ξ2-ξ3))*det

    return sum
end

function k4p_ce_B(f, x1, x2, y1, y2)
    #sum = 0;
    #Domain 2-5
    #=1=#   ξ1 = x1
    #=2=#   ξ2 = x2
    #=3=#   ξ3 = x2 * y1
    #=4=#   ξ4 = x2 * y2

    det = x2^2

    sum=f((1-ξ1,ξ2),(1-(ξ1-ξ4),ξ3-ξ4))*det

    sum+=f((1-(ξ1-ξ3),(ξ2-ξ3)),(1-ξ1,ξ4))*det

    sum+=f((1-(ξ1-ξ4),(ξ3-ξ4)),(1-ξ1,ξ2))*det

    sum+=f((1-(ξ1-ξ4),(ξ2-ξ4)),(1-ξ1,ξ3))*det

    return sum
end

### Common vertex ###
function k4p_cv(f,η1, η2, η3, ξ)

	ξη1 = ξ * η1
	ξη2 = ξ * η2

	(ξ^3)*η2*(

	f((1-ξ, ξη1), (1-ξη2, ξη2*η3)) +  f((1-ξη2, ξη2*η3), (1-ξ, ξη1))

	)
end

function k4p_cv_A(f,x1, x2, y1, y2)

	(x1^2)*(

	f((1-x1, x2), (1-x1*y1, x1*y2)) +  f((1-x1*y1, x1*y2), (1-x1, x2))

	)
end

### Positive Distance ###
function k4p_pd(f,x1, x2, y1, y2)
	(x1*y1)*f((1-x1, x1*x2), (1-y1, y1*y2)) 
end

function k4p_pd_A(f,x1, x2, y1, y2)
	f((1-x1, x2), (1-y1, y2)) 
end

#=
function k3p_cf_orig2(f, η1, η2, η3, ξ)

	(ξ^3)*((η1)^2)*(η2)*(

    f((1-ξ, ξ*η1), (1-(ξ-ξ*η1*η2*η3), ξ*η1-ξ*η1*η2))  +

	f((1-(ξ-ξ*η1*η2*η3), ξ*η1-ξ*η1*η2), (1-ξ, ξ*η1)) +

	f((1-ξ, ξ*η1*(1-η2+η2*η3)), (1-(ξ-ξ*η1*η2), ξ*η1*(1-η2))) +

	f((1-(ξ-ξ*η1*η2), ξ*η1*(1-η2)), (1-ξ, ξ*η1*(1-η2+η2*η3))) +

	f((1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)), (1-ξ, ξ*η1*(1-η2))) +

	f((1-ξ, ξ*η1*(1-η2)), (1-(ξ-ξ*η1*η2*η3), ξ*η1*(1-η2*η3)))

	)
end

function k3p_cf_new(f, ξ1, ξ2, η1, η2)

	(ξ1^3)*(ξ2^2)*(η1)*(

    #OK
    f((1-ξ1, ξ1*ξ2), (1-(ξ1-ξ1*ξ2*η1+ξ1*ξ2*η1*η2), ξ1*ξ2-ξ1*ξ2*η1))  +
    #OK
    f((1-ξ1, ξ1*ξ2-ξ1*ξ2*η1+ξ1*ξ2*η1*η2), (1-(ξ1-ξ1*ξ2*η1), ξ1*ξ2-ξ1*ξ2*η1)) +
    #OK
    f((1-ξ1, ξ1*ξ2-ξ1*ξ2*η1), (1-(ξ1-ξ1*ξ2*η1*η2), ξ1*ξ2-ξ1*ξ2*η1*η2)) +
    #OK
    f((1-(ξ1-ξ1*ξ2*η1*η2), ξ1*ξ2-ξ1*ξ2*η1*η2),(1-ξ1, ξ1*ξ2-ξ1*ξ2*η1)) +
    #OK
    f((1-(ξ1-ξ1*ξ2*η1), ξ1*ξ2-ξ1*ξ2*η1),(1-ξ1, ξ1*ξ2-ξ1*ξ2*η1+ξ1*ξ2*η1*η2)) +
	#OK
    f( (1-(ξ1-ξ1*ξ2*η1+ξ1*ξ2*η1*η2), ξ1*ξ2-ξ1*ξ2*η1),(1-ξ1, ξ1*ξ2))  
	)
end

function k3p_cf_gm(f, ξ1, ξ2, η1, η2)

	(η1)*(

    #OK
    f((1-ξ1, ξ2), (1-(ξ1-η1+η1*η2), ξ2-η1))  +
    #OK
    f((1-ξ1, ξ2-η1+η1*η2), (1-(ξ1-η1), ξ2-η1)) +
    #OK
    f((1-ξ1, ξ2-η1), (1-(ξ1-η1*η2), ξ2-η1*η2)) +
    #OK
    f((1-(ξ1-η1*η2), ξ2-η1*η2),(1-ξ1, ξ2-η1)) +
    #OK
    f((1-(ξ1-η1), ξ2-η1),(1-ξ1, ξ2-η1+η1*η2)) +
	#OK
    f( (1-(ξ1-η1+η1*η2), ξ2-η1),(1-ξ1, ξ2))  
	)
end
=#
#=
function k3p_ce_new(f, ξ1, ξ2, η1, η2)


    #OK
    (ξ1^3)*(ξ2^2) * f((1-ξ1, ξ1*ξ2-ξ1*ξ2*η2), (1-(ξ1*ξ2*η1-ξ1*ξ2+ξ1), ξ1*ξ2*η1))  +

	(ξ1^3)*(ξ2^2)*(η1)*(
    #OK
	f((1-ξ1, ξ1*ξ2*η1-ξ1*ξ2+ξ1), (1-ξ1*ξ2, ξ1*ξ2*η1-ξ1*ξ2*η1*η2)) +
    #OK
    f((1-(ξ1-ξ1*ξ2*η1), ξ1*ξ2-ξ1*ξ2*η1), (1-ξ1, ξ1*ξ2*η1*η2)) +
    #OK
	f((1-(ξ1-ξ1*ξ2*η1*η2), ξ1*ξ2*η1-ξ1*ξ2*η1*η2), (1-ξ1, ξ1*ξ2)) +
    #OK
	f((1-(ξ1-ξ1*ξ2*η1+ξ1*ξ2*η1*η2), ξ1*ξ2*η1*η2-ξ1*ξ2*η1+ξ1*ξ2), (1-ξ1, ξ1*ξ2*η1))

	)
end


function k3p_ce_gm(f, ξ1, ξ2, η1, η2)


    #OK
    (ξ2^2) * f((1-ξ1, ξ2-ξ2*η2), (1-(ξ2*η1-ξ2+ξ1), ξ2*η1))  +

	(ξ2^2)*(η1)*(
    #OK
	f((1-ξ1, ξ2*η1-ξ2+ξ1), (1-ξ2, ξ2*η1-ξ2*η1*η2)) +
    #OK
    f((1-(ξ1-ξ2*η1), ξ2-ξ2*η1), (1-ξ1, ξ2*η1*η2)) +
    #OK
	f((1-(ξ1-ξ2*η1*η2), ξ2*η1-ξ2*η1*η2), (1-ξ1, ξ2)) +
    #OK
	f((1-(ξ1-ξ2*η1+ξ2*η1*η2), ξ2*η1*η2-ξ2*η1+ξ2), (1-ξ1, ξ2*η1))

	)
end
=#

#=
function k3p_cv_gm(f,ξ1, ξ2, η1, η2)

    
    (ξ1^2)*(

	f((1-ξ1, ξ2), (1-ξ1*η1, ξ1*η2)) +  f((1-ξ1*η1, ξ1*η2), (1-ξ1, ξ2))

    )
    
    #=
	(ξ1^2)*η1*(

	f((1-ξ1, ξ2), (1-ξ1*η1, ξ1*η1*η2)) +  f((1-ξ1*η1, ξ1*η1*η2), (1-ξ1, ξ2))

    )
    =#
end
=#